
Redmine - Feature #1875

Issue filtering on author only uses members of project

2008-09-09 08:00 - James Turnbull

Status: New Start date: 2008-09-09

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues filter Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

We allow non-members of project to add issues and hence they are then authors of the issues they create.  The issue filter query

only gathers users/authors who are members of the project hence our list of authors to query on is incomplete.

# members of the user's projects

user_values += User.current.projects.collect(&:users).flatten.uniq.sort.collect{|s| [s.name, s.id.

to_s]     }

 Not sure what the best way to fix/address this is...

Related issues:

Has duplicate Redmine - Feature #11606: Filter on Author should include all A... Closed

Has duplicate Redmine - Feature #4398: Author Issue-filter only contains memb... Closed 2009-12-14

Has duplicate Redmine - Defect #21075: User without role in project is not sh... Closed

History

#1 - 2008-09-13 18:48 - Jean-Philippe Lang

I have this issue here too. I'd like to see tickets submitted by any user.

But loading thousands of users in the drop-down is not a good solution.

This would require some changes in the Query model and to replace the field with a sort of auto-complete field.

#2 - 2008-09-13 18:53 - Jean-Philippe Lang

If displaying the list of all users is not a problem for you, you can use:

user_values += User.find(:all).sort.collect{|s| [s.name, s.id.to_s] }

#3 - 2012-08-08 22:40 - Jan Niggemann (redmine.org team member)

jp jp: Where would I use that?

#4 - 2012-08-09 01:14 - Cheyenne Wills

Understand about the size of the list.  Maybe a option setting?

I think you can limit the size of the list by using just those userids that are in the issues for the project/tracker (still could be thousands for a internet

wide "public" project)

#5 - 2013-02-06 11:51 - Daniel Felix

- Affected version (unused) changed from 0.7.3 to 2.2.2

- Affected version changed from 0.7.3 to 2.2.2

Still able to use see this.

Maybe this could be changed with a simple project setting.

For example:

allow ticket assignment to:

only project members

project members + author

2025-08-23 1/3

https://www.redmine.org/users/585


systemwide members (which implies, that assigned to should be a input field with autocomplete, because the list will be too large)

What do you think about this suggestion?

#6 - 2015-11-02 14:20 - Toshi MARUYAMA

- Tracker changed from Defect to Feature

#7 - 2015-11-02 14:23 - Toshi MARUYAMA

- Has duplicate Feature #4398: Author Issue-filter only contains members even when non-members have 'create issue' permission added

#8 - 2015-11-02 14:25 - Toshi MARUYAMA

FTR:

Jean-Philippe Lang wrote at #4398#note-1:

We can not list all users in this field, we need to change this filter to an auto-complete field first.

#9 - 2015-11-13 04:46 - Alexey Poliansky

issues_query.rb

173c177,187

<     author_values += users.collect{|s| [s.name, s.id.to_s] }

---

>    if project 

>      from_user = []

>      project.issues.group(:author_id).each{|i| from_user << [i.author.name, i.author_id.to_s]}

>      from_user.uniq!

>      from_user.sort!

>      author_values += from_user

>      else

>      author_values += users.collect{|s| [s.name, s.id.to_s] }

>      end

 this way works but slow when big amount of issues

(After adding group(:author_id) - works much faster)

#10 - 2015-11-15 08:26 - Alexey Poliansky

173c174,182

<     author_values += users.collect{|s| [s.name, s.id.to_s] }

---

>    if project 

>       time_range = (Time.now - (3600*24*180))..(Time.now)

>       author_values += project.issues.where(issues: { created_on: time_range }).group(:author_id).preload(:a

uthor).collect{|s| [s.author.name, s.author_id.to_s]}

>      author_values.sort!

>      else

>      author_values += users.collect{|s| [s.name, s.id.to_s] }

>      end

Another version to work in workflow project, select only authors in last half-year tasks

#11 - 2017-11-05 08:06 - Go MAEDA

- Category changed from Issues to Issues filter

#12 - 2017-11-05 08:08 - Go MAEDA

- Has duplicate Defect #21075: User without role in project is not shown as a selection option in Author filter (Issues tab) added

#13 - 2021-11-22 20:32 - Sebastian Paluch

+1

This is long waited and reported multiple times. Any chance to get this done?

#14 - 2022-01-27 21:43 - Alexey Poliansky

Another try to solve this issue. for me it's work fine for about 250 active users.
in issue_query.rb after author_values=[]

if project

        from_user = []

        time_range = (Time.now - (3600*24*730))..(Time.now)

        issues_cross = Issue.cross_project_scope(project, 'descendants')

        from_user += issues_cross.where(issues: { created_on: time_range }).group(:author_id).preload(:author)

.collect{|i| [i.author.name, i.author_id.to_s]}

        from_user.uniq!

        from_user.sort!

        author_values += from_user

 time_range not required but for me a little helpful...
